export interface GeneratedFieldTemplate<F> {
    generator: () => F;
}
export declare function isGenerated<F, T extends Template<F>>(fieldTemplate: FieldTemplate<F, T>): fieldTemplate is GeneratedFieldTemplate<F>;
export interface DefaultFieldTemplate<F> {
    default: F;
}
export declare function isDefault<F, T extends Template<F>>(fieldTemplate: FieldTemplate<F, T>): fieldTemplate is DefaultFieldTemplate<F>;
export interface NestedFieldTemplate<F, T extends Template<F>> {
    nested: BuilderClass<F, T>;
}
export declare function isNested<F, T extends Template<F>>(fieldTemplate: FieldTemplate<F, T>): fieldTemplate is NestedFieldTemplate<F, T>;
export declare type FieldTemplate<F, T extends Template<F>> = GeneratedFieldTemplate<F> | DefaultFieldTemplate<F> | NestedFieldTemplate<F, T>;
export declare type Template<R> = {
    [P in keyof R]-?: FieldTemplate<R[P], Template<R[P]>>;
};
declare type ScalarSetterFn<F, Self> = (value: F) => Self;
declare type NestedSetterFn<F, T extends Template<F>, Self> = (block: (builder: Builder<F, T>) => any) => Self;
declare type SetterFn<F, T, Self> = T extends NestedFieldTemplate<infer SF, infer ST> ? NestedSetterFn<SF, ST, Self> : ScalarSetterFn<F, Self>;
export declare type Builder<R, T extends Template<R>> = {
    readonly [P in keyof R]-?: SetterFn<R[P], T[P], Builder<R, T>>;
} & {
    build(): R;
};
export declare type BuilderClass<R, T extends Template<R>> = {
    new (): Builder<R, T>;
};
export {};
//# sourceMappingURL=types.d.ts.map